
 Const c_playerface%  = 1
 Const c_sprites%     = 13
 Const c_coin%        = 0
 Const c_coincount%   = 3
 Const c_lip%         = 40
 Const c_dia%         = 52
 Const c_sc_width%    = 1024	
 Const c_sc_height%   = 768
 Const c_changedir%   = 40
 Const c_scorefile$   = "score.dat"
 Const c_ChangeScore% = 350

 
 Global sprites%
 Global bg_back%
 Global sd_pling%
 Global sd_haha%

 Global DrawScore%
 
 Global peoplecount%

 Global playerface%
 Global points%
 Global timer%

 Dim scr_points%(9)
 Dim scr_name$(9)
 Dim names$(c_sprites%)

 names$(1)  = "Spieler" 
 names$(2)  = "Gegner" 
 names$(3)  = "Gegner" 
 names$(4)  = "Gegner" 
 names$(5)  = "Gegner" 
 names$(6)  = "Gegner" 
 names$(7)  = "Gegner" 
 names$(8)  = "Gegner" 
 names$(9)  = "Gegner" 
 names$(10) = "Gegner" 
 names$(11) = "Gegner" 
 names$(12) = "Gegner" 


;analyse Commandline
  ScreenMode% = 1 

  If Instr(Upper(CommandLine$()),"WINDOW") Then ScreenMode% = 3 


 Graphics c_sc_width%, c_sc_height%, 16, ScreenMode%
 SetBuffer BackBuffer()


 timer% = CreateTimer(60)
 SeedRnd MilliSecs()

 LoadScore()
  
 font% = LoadFont ("Comic Sans MS", 40,1)
 SetFont Font%

 sd_pling% = LoadSound("pling.wav")
 If Not sd_pling% Then RuntimeError "Couldn't load pling.wav" 

 sd_haha% = LoadSound("haha.wav")
 If Not sd_pling% Then RuntimeError "Couldn't load haha.wav" 


 bg_back% = LoadImage("back.jpg")
 If Not bg_back% Then RuntimeError "Couldn't load back.jpg"

 AutoMidHandle True
 sprites% = LoadAnimImage("graphic.png",c_dia%,c_dia%,0,c_sprites%)
 If Not sprites% Then RuntimeError "Couldn't load graphic.png"
 MaskImage sprites%, 255,0,255


 Type people
   Field face%
   Field xpos%
   Field xdir%
   Field ypos% 
   Field ydir% 
 End Type

 Type coin
   Field xpos%
   Field ypos%
 End Type

 Dim enemy%(c_sprites%)



Repeat

 menu()
 Initialize()

 Repeat

   HandlePeople()
   MovePeople()

   Draw()

   WaitTimer(timer%)
   Flip
   
 Until KeyHit(1) Or HandleCollision()  
  

Forever




Function Draw()

;   Cls

   DrawBlock bg_back%, 0, 0

   For euro.coin = Each coin
      DrawImage sprites%, euro\xpos%, euro\ypos%, c_coin% 
   Next

   For person.people = Each people
      DrawImage sprites%, person\xpos%, person\ypos%, person\face% 
   Next

   Text 10, 10, "Punkte: " + points%

End Function 

Function CreatePeople(face%, xpos%, ypos%, xdir%=0, ydir%=0)

   person.people = New people

   person\face% = face%
   person\xpos% = xpos%
   person\ypos% = ypos%
   person\xdir% = xdir%
   person\ydir% = ydir%

   If face% = c_playerface% Then Return Handle(person)

End Function


Function HandlePeople()

   peoplecount% = 0
   For person.people = Each people

      peoplecount% = peoplecount% + 1
      If person\face% = c_playerface% Then 
 
         person\xdir% = 0
         person\ydir% = 0
         If person\xpos% > c_lip% And KeyDown(203) Then person\xdir% = -1
         If person\xpos% < c_sc_width% - c_lip% And KeyDown(205) Then person\xdir% =  +1 
         If person\ypos% > c_lip% And KeyDown(200) Then person\ydir% = -1 
         If person\ypos% < c_sc_height% - c_lip% And KeyDown(208) Then person\ydir% = +1   

      Else

         If Not Rand(0,c_changedir%) Then person\xdir% = Rand(-1,1)  
         If Not Rand(0,c_changedir%) Then person\ydir% = Rand(-1,1) 
 
         If person\xpos% < c_lip%  Then person\xdir% = +1
         If person\xpos% > c_sc_width% - c_lip%  Then person\xdir% =  -1 
         If person\ypos% < c_lip% Then person\ydir% = +1 
         If person\ypos% > c_sc_height% - c_lip% Then person\ydir% = -1       

      EndIf
   Next

End Function

Function HandleCollision()
   
   player.people = Object.people(playerface%)

   For euro.coin = Each coin
       If Collision(euro\xpos%, euro\ypos%, player\xpos%, player\ypos%) Then 
          Delete euro.coin
          points% = points% + 1
          CreateCoin(player.people)
          CreateNPC(player.people)
          PlaySound(sd_pling%)
       EndIf
   Next 

   For person.people = Each people
      If person\face% <> c_playerface% And Collision(person\xpos%, person\ypos%, player\xpos%, player\ypos%) Then 
         FlushKeys()
         PlaySound(sd_haha%)
         Repeat
            If KeyHit(1) Or KeyHit(28) Then Return HighScore()
             
         Forever
      EndIf 
   Next

End Function

Function MovePeople()

   For person.people = Each people

     If person\xdir% And person\ydir% Then multi% = 3 Else multi% = 4  
 
     person\xpos% = person\xpos% + person\xdir% * multi%
     person\ypos% = person\ypos% + person\ydir% * multi%

   Next 

End Function

Function Collision(xpos1%, ypos1%, xpos2%, ypos2%,diameter% = c_dia%)

   If xpos1% - diameter% < xpos2% And xpos1% + diameter% > xpos2% And ypos1% - diameter% < ypos2% And ypos1% + diameter% > ypos2% Then
      If ((xpos1%-xpos2%)^2 + (ypos1%-ypos2%)^2)^0.5 < diameter% Then Return 1   
   EndIf

End Function


Function CreateCoin(player.people)

    
   xpos% = Rand(c_lip%, c_sc_width% - c_lip%)
   ypos% = Rand(c_lip%, c_sc_height% - c_lip%)  
      
   If Collision(xpos%, ypos%, player\xpos%, player\ypos%, c_dia% * 5) Then Return CreateCoin(player.people)

   For euro.coin = Each coin
      If Collision(xpos%,ypos%,euro\xpos%, euro\ypos%, c_dia% * 2) Then Return CreateCoin(player.people)
   Next  

   euro.coin = New coin
   euro\xpos% = xpos%
   euro\ypos% = ypos%

End Function 

Function CreateNPC(player.people)
  
   If peoplecount% > c_sprites% - 2 Then Return 1

   Repeat
      xpos% = Rand(c_lip%, c_sc_width% - c_lip%)
      ypos% = Rand(c_lip%, c_sc_height% - c_lip%) 
     
   Until Not Collision(xpos%, ypos%, player\xpos%, player\ypos%, c_dia% * 5) 

   Repeat 
      face% = Rand(c_playerface%+1,c_sprites%-1)
   Until Not enemy%(face%) 
   enemy%(face%) = 1
 
   CreatePeople(face%, xpos%, ypos%, Rand(-1,1), Rand(-1,1))
  

End Function


Function Initialize()

 DrawScore% = 0
 peoplecount% = 0
 points% = 0
 For person.people = Each people
     Delete person.people
 Next

 For euro.coin = Each coin
     Delete euro.coin
 Next

 For i% = 0 To c_sprites%
    enemy(i%) = 0
 Next

 playerface% = CreatePeople(c_playerface%, 320, 240)

 player.people = Object.people(playerface%)
 
 For i% = 1 To c_coincount%
    CreateCoin(player.people)   
 Next 

 CreateNPC(player.people)


End Function

Function Menu()

 FlushKeys() 
 Repeat
    DrawBlock bg_back%, 0, 0

    If DrawScore% < c_ChangeScore%
       DrawPeople()
    Else
       DrawScore()
    EndIf 
 
    DrawScore% = DrawScore% + 1
    If DrawScore% > c_ChangeScore% * 2 Then DrawScore% = 0


    WaitTimer(timer%)
    Flip

    a = GetKey()
 Until a 

 If a = 27 Then 
    WriteScore()
    End
 EndIf

End Function


Function LoadScore()

 file% = ReadFile(c_scorefile$)

 If Not file% Then Return InitScore()

 For i% = 0 To 9
    scr_points%(i%) = ReadInt(file%)
    scr_name$(i%) = ReadString(file%)
 Next

End Function

Function InitScore()

 For i% = 0 To 9
    scr_points%(i%) = 10 - i%
    scr_name$(i%) = "Hau mich raus!"
 Next

End Function


Function WriteScore()

 file% = WriteFile (c_scorefile$)

 For i% = 0 To 9
    WriteInt file%, scr_points%(i%) 
    WriteString file%, scr_name$(i%)
 Next 

End Function

Function HighScore()

 DrawScore% = c_ChangeScore%
 If points% <= scr_points%(9) Then Return 1
 DrawBlock bg_back%, 0, 0
 
 Flip

 FlushKeys()
 Locate 100, 250
 Print "Du darfst dich mit " + points% + " Punkten in die Highscore eintragen!"
 Locate 460, 300
 name$ = Input$()

 If name$ <> "" Then 
    For i% = 0 To 9    
       If points% > scr_points%(i%) Then

          For l% = 8 To i% Step -1
             scr_points%(l%+1) = scr_points%(l%) 
             scr_name$(l%+1) = scr_name$(l%) 
          Next
          scr_points%(i%) = points%            
          scr_name$(i%) = name$  
          Return 1

       EndIf
    Next
 EndIf
 Return 1

End Function


Function DrawScore()


 Text 350, 250, "H I G H S C O R E:"

 For i% = 0 To 9
    ypos% = 300 + i% * 35

    Text 250, ypos%, i% + 1 + ".  " 
    Text 400, ypos%, scr_name$(i%) 
    Text 700, ypos%, RSet$(scr_points%(i%),3)

 Next 


End Function


Function DrawPeople()


 Text 350, 250, " S T A R R I N G:"
 
 For i% = c_playerface% To c_sprites% - 1
    ypos% = 300 + i% * 30
    If i% Mod 2 Then 
       Text 330, ypos%-25, names$(i%)      
       DrawImage sprites%, 280, ypos%, i% 
    Else
       Text 400, ypos%-55, RSet$(names$(i%),21)      
       DrawImage sprites%, 740, ypos%-30, i% 
    EndIf
 Next


End Function

